#!/bin/sh
# $Id: webcore-fonts-installer.SlackBuild,v 1.4 2014/10/20 09:42:50 root Exp root $
# Copyright 2013  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:          Eric Hameleers <alien@slackware.com>
# For:         webcore-fonts-installer
# Descr:       installs Microsoft core fonts for the web
# URL:         http://avi.alkalay.net/linux/docs/font-howto/Font.html#msfonts
# Needs:       
# Changelog:   
# 3.0-1:      03/Nov/2013 by Eric Hameleers <alien@slackware.com>
#              * Initial build.
# 3.0-2:      15/Nov/2013 by Eric Hameleers <alien@slackware.com>
#              * By adding placeholder files inside the package, ensure that
#                'removepkg' will also remove the downloaded fonts.
# 3.0-3:      20/oct/2014 by Eric Hameleers <alien@slackware.com>
#              * Original source disappeared from the Web. Using a copy now.
# 
# Run 'sh webcore-fonts-installer.SlackBuild' to build a Slackware package.
# The package (.tgz) and .txt file as well as build logs are created in /tmp .
# Install it using 'installpkg'. 
#
# -----------------------------------------------------------------------------

PRGNAM=webcore-fonts-installer
VERSION=${VERSION:-3.0}
ARCH=noarch
BUILD=${BUILD:-3}
NUMJOBS=${NUMJOBS:" -j4 "}
TAG=${TAG:-alien}

DOCS="ABOUT* AUTHORS BUGS ChangeLog* COPYING CREDITS FAQ GPL* HACKING \
      LICENSE MAINTAINERS NEWS README* TODO"

# Where the fonts go:
FONTDIR="/usr/share/fonts/TTF"

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

# Where are the fonts?
SRCURL="http://taper.alienbase.nl/fonts/webcore-fonts-${VERSION}.tar.gz"

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
                          # remove old log files

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

# This package really installs nothing but the SlackBuild script itself.
# The post-install script will do the actual downloading and will install
# the fonts. This way, no license is breached - you as the enduser are free
# to download and use the MS fonts.

# This command was used to create zero-byte placeholder files for the downloade
# fonts, so that "removepkg webcore-fonts-installer" will actually remove the
# downloaded font files and documentation as well:
# mkdir -p tmp/usr/share/fonts/TTF
# tar -ztvf webcore-fonts-3.0.tar.gz | grep -E '/vista/|/fonts/' | rev | cut -d/ -f1 | rev |xargs -I{} touch tmp/usr/share/fonts/TTF/{}
# mkdir -p tmp/usr/doc/webcore-fonts-installer
# tar -ztvf webcore-fonts-3.0.tar.gz | grep /doc/ | rev | cut -d/ -f1 | rev |xargs -I{} touch tmp/usr/doc/webcore-fonts-installer/{}
# (cd tmp && tar -zcvf ../_webcore-fonts-installer.tar.gz .)

# Explode the package framework:
if [ -f $SRCDIR/_$PRGNAM.tar.gz ]; then
  cd $PKG
  explodepkg $SRCDIR/_$PRGNAM.tar.gz
  mv usr/doc/$PRGNAM usr/doc/$PRGNAM-$VERSION
  cd -
fi

# Post-install script:
mkdir -p $PKG/install
cat <<EOT > $PKG/install/doinst.sh
echo "**"
echo "** Downloading Web Core Fonts..."
echo "**"
TEMPOUT=\$(mktemp -t -d alien.XXXXXX)
wget -nv -T 20 -O - "${SRCURL}" | tar -C\${TEMPOUT} -zxf -
if [ \$? -ne 0 ]; then
  echo "** Downloading the Web Core fonts failed... aborting the install."
  exit 1
else
  echo "** Installing Web Core Fonts..."
  chown -R root:root \${TEMPOUT}/*
  chmod -R u+w,go+r-w,a+X-s \${TEMPOUT}/*
fi

# Move the fonts plus documentation into the system
# (yes, this causes pollution which remains after package uninstallation):
mkdir -p ./$FONTDIR
cp \${TEMPOUT}/webcore-fonts/fonts/* ./$FONTDIR
cp \${TEMPOUT}/webcore-fonts/vista/* ./$FONTDIR
cp \${TEMPOUT}/webcore-fonts/doc/* ./usr/doc/$PRGNAM-$VERSION

# Clean up:
rm -rf \${TEMPOUT}

# Update X font indexes and the font cache:
if [ -x usr/bin/mkfontdir ]; then
  chroot . /usr/bin/mkfontscale $FONTDIR
  chroot . /usr/bin/mkfontdir $FONTDIR
fi
if [ -x usr/bin/fc-cache ]; then
  chroot . /usr/bin/fc-cache $FONTDIR
fi
EOT

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt

# Restore the original umask:
umask ${_UMASK_}

